# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class BulkOpStatus(str, enum.Enum):
    """
    ℹ️ This enum is non-exhaustive.
    """

    IN_PROGRESS = "in_progress"
    SUCCESS = "success"
    FAILURE = "failure"
    ABORTED = "aborted"

    def visit(
        self,
        in_progress: typing.Callable[[], T_Result],
        success: typing.Callable[[], T_Result],
        failure: typing.Callable[[], T_Result],
        aborted: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is BulkOpStatus.IN_PROGRESS:
            return in_progress()
        if self is BulkOpStatus.SUCCESS:
            return success()
        if self is BulkOpStatus.FAILURE:
            return failure()
        if self is BulkOpStatus.ABORTED:
            return aborted()
